//ADC0 == Entfernungssensor nach vorn
//ADC1 == Entfernungssensor zur linken Seite

//ADC6 == Motorstrom LINKS
//ADC5 == Motorstrom RECHTS

class SENSOR
{
    public:
        int merk0,merk1,merk2,merk3;
        int wert0,wert1,wert2,wert3;
        int DURCHLAUF;
        unsigned char akku, akku2;

        SENSOR()
        {
            ADCSRA = (1<<ADEN) | (1<<ADSC) | (1<<ADATE) | (0<<ADIF) | (0<<ADIE) | (1<<ADPS2) | (1<<ADPS1) | (0<<ADPS0);
            ADMUX = (0<<REFS1) | (1<<REFS0) | (1<<ADLAR) | (0<<MUX4) | (0<<MUX3) | (0<<MUX2) | (0<<MUX1) | (0<<MUX0);
            DDRA &= 0b11111110;        

            wert0=0;
            wert1=0;
            wert2=0;
            wert3=0;
            merk0=0;
            merk1=0;
            merk2=0;
            merk3=0;
    
            DURCHLAUF=0;
            akku=0;
            akku2=0;            
        }

        void aktualisieren()
        {
            //Abhängig von den Durchlaeufen zwischen den Kanälen umschalten,
            //initialisieren und Mittelwert bilden:

            switch(DURCHLAUF)
            {
                case 0:
                case 1:
                case 2:
                case 3:
                case 4:
                    akku2  = ADCL; //muss erst ausgelesen werden, damit ADCL verfügbar ist
                    akku   = ADCH;
                    merk0 += (akku<<2) | (akku2>>6);            
                break;

                case 5:
                    //Auf ADW 1 umschalten:
                    ADMUX = (0<<REFS1) | (1<<REFS0) | (1<<ADLAR) | (0<<MUX4) | (0<<MUX3) | (0<<MUX2) | (0<<MUX1) | (1<<MUX0);
                    wert0=merk0/5;
                    merk0=0;
                break;

                case 10:
                case 11:
                case 12:
                case 13:
                case 14:
                    akku2  = ADCL; //muss erst ausgelesen werden, damit ADCL verfügbar ist
                    akku   = ADCH;
                    merk1 += (akku<<2) | (akku2>>6);            
                break;

                case 15:
                    //Auf ADC 5 umschalten, MOTOR STROM RECHTS:
                    ADMUX = (0<<REFS1) | (1<<REFS0) | (1<<ADLAR) | (0<<MUX4) | (0<<MUX3) | (1<<MUX2) | (0<<MUX1) | (1<<MUX0);
                    wert1=merk1/5;
                    merk1=0;
                break;



                //STROMSENSOREN

                case 20:
                case 21:
                case 22:
                case 23:
                case 24:
                    akku2  = ADCL; //muss erst ausgelesen werden, damit ADCL verfügbar ist
                    akku   = ADCH;
                    merk2 += (akku<<2) | (akku2>>6);            
                break;

                case 25:
                    //Auf ADC 6 umschalten, MOTOR STROM LINKS:
                    ADMUX = (0<<REFS1) | (1<<REFS0) | (1<<ADLAR) | (0<<MUX4) | (0<<MUX3) | (1<<MUX2) | (1<<MUX1) | (0<<MUX0);
                    wert2=merk2/5;
                    merk2=0;
                break;

                case 26:
                case 27:
                case 28:
                case 29:
                case 30:
                    akku2  = ADCL; //muss erst ausgelesen werden, damit ADCL verfügbar ist
                    akku   = ADCH;
                    merk3 += (akku<<2) | (akku2>>6);            
                break;

                case 31:
                    //Auf ADW 0 umschalten:
                    ADMUX = (0<<REFS1) | (1<<REFS0) | (1<<ADLAR) | (0<<MUX4) | (0<<MUX3) | (0<<MUX2) | (0<<MUX1) | (0<<MUX0);
                    wert3=merk3/5;
                    merk3=0;
                break;

            }

            DURCHLAUF++;
            DURCHLAUF%=36;
        }
        
        int holeWert0()
        {
            return wert0;
        }
        int holeWert1()
        {
            return wert1;
        }
        int holeWert2()
        {
            return wert1;
        }
        int holeWert3()
        {
            return wert1;
        }
} sensor;